(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react')) :
  typeof define === 'function' && define.amd ? define(['react'], factory) :
  (global = global || self, global['react-bungee'] = factory(global.React));
}(this, function (React) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  var determineHeight = function determineHeight(height, ref) {
    if (!ref.current) return;
    var measuredHeight = ref.current.scrollHeight;
    height = height.toString();
    if (height === 'auto') return "".concat(measuredHeight, "px");else if (height.includes('%')) return "".concat(measuredHeight * (height.substr(0, height.indexOf('%')) / 100), "px");else return "".concat(height, "px");
  };

  var index = (function (_ref) {
    var height = _ref.height,
        children = _ref.children,
        componentClassName = _ref.componentClassName,
        componentStyle = _ref.componentStyle,
        _ref$duration = _ref.duration,
        duration = _ref$duration === void 0 ? 500 : _ref$duration,
        _ref$easing = _ref.easing,
        easing = _ref$easing === void 0 ? 'ease-in-out' : _ref$easing,
        _ref$delay = _ref.delay,
        delay = _ref$delay === void 0 ? 0 : _ref$delay,
        onBefore = _ref.onBefore,
        onAfter = _ref.onAfter,
        props = _objectWithoutProperties(_ref, ["height", "children", "componentClassName", "componentStyle", "duration", "easing", "delay", "onBefore", "onAfter"]);

    var containerRef = React.useRef(null);

    var _useState = React.useState(determineHeight(height, containerRef)),
        _useState2 = _slicedToArray(_useState, 2),
        computedHeight = _useState2[0],
        setComputedHeight = _useState2[1];

    React.useEffect(function () {
      var newHeight = determineHeight(height, containerRef);
      var allHeights = {
        given: height,
        computed: newHeight
      };
      if (onBefore) onBefore(allHeights);
      setComputedHeight(newHeight);
      if (onAfter) setTimeout(function () {
        return onAfter(allHeights);
      }, delay + duration);
    }, [height]);

    var componentStyles = _objectSpread({
      height: computedHeight,
      overflow: 'hidden',
      transition: "height ".concat(duration, "ms ").concat(easing, " ").concat(delay, "ms")
    }, componentStyle);

    return React__default.createElement("div", {
      ref: containerRef,
      style: componentStyles,
      className: componentClassName
    }, React__default.createElement("div", props, children));
  });

  return index;

}));
